from modules.command import Command
from modules.task import Task
from modules.test import TEST
from modules.key import Key

action_methods = {

    # --- for command ---
    'Command.cmd001': (Command, 'cmd001', 'NoBack'),  # update code by git commit
    'Command.cmd002': (Command, 'cmd002', 'NoBack'),  # update pth by apache server
    'Command.cmd003': (Command, 'cmd003', 'IsBack'),  # docker ps
    'Command.cmd004': (Command, 'cmd004', 'IsBack'),  # docker images

    # --- 初始化操作接口 ---
    'Key.create_key': (Key, 'create_key', 'IsBack'),  # 生成key
    'Key.verify_key': (Key, 'verify_key', 'IsBack'),  # 验证key

    # --- for task ---
    'Task.task002': (Task, 'task002', 'IsBack'),  # 接收 fastapi 发送来的 uuid 并计算人脸存储特征 同样提供判断该照片是否能用
    'Task.task003': (Task, 'task003', 'IsBack'),  # 为8301接口提供业务支持

    # --- for test ---
    'TEST.test002': (TEST, 'test002', 'NoBack'),  # 刷超分人脸图片接口 将超分图片加入到底库中
    'TEST.test001': (TEST, 'test001', 'NoBack'),  # 批量导入人脸特征数据 from mariadb to mongodb
    'TEST.test004': (TEST, 'test004', 'NoBack'),  # 更新 mongo.VisitorTags 表数据
    'TEST.test006': (TEST, 'test006', 'IsBack'),  # 对比人脸特征
    'TEST.test007': (TEST, 'test007', 'IsBack'),  # 测试websocket在线信息
    'TEST.test008': (TEST, 'test008', 'IsBack'),  # test
    'TEST.test009': (TEST, 'test009', 'IsBack'),  # test
    'TEST.test011': (TEST, 'test011', 'IsBack'),  # 下载语音文件
    'TEST.test012': (TEST, 'test012', 'IsBack'),  # 录入人脸图片
    'TEST.test013': (TEST, 'test013', 'IsBack'),  # 对比人脸图像的相似度
    'TEST.test014': (TEST, 'test014', 'IsBack'),  # 对比人脸图像的相似度
    'TEST.test015': (TEST, 'test015', 'IsBack'),  # 检索相似人脸

}
